.if t .po +0.5c
.ds ` ""
.if t .ds ` ``
.ds ' ""
.if t .ds ' ''
.TH FLPR 1 "Fermi"
.SH NAME
flpr, flpq, flpk \- Fermilab version of lpr/lpd programs
.SH SYNOPSIS
.B "flpr [[\-h\fIhost\fB] [\-q\fIqueue\fB]|[\-P\fIprinter\fB]] [\-l\fIlogin\fB] [\-I\fIidentifier\fB] [\-j\fIjobname\fB] [\-c\fIclassname\fB] [\-u\fIfullname\fB] [\-i\fIindent\fB] [\-w\fIwidth\fB] [\-n\fInotify\fB] [\fI\-C\fB] [\fI\-V[V]\fB] [\fI\-v\fB] [\fI\-\\\\?\fB] [\fI\-E[E]\fB] [\fI\-S\fB] [\fI\-T\fB] [\fI\-Q\fB] [\fI\-@pattern\fB] [\fI\-W[W]\fB] [\fI\-m\fB] [\fIfile\fB] ..."
.sp
.B "flpq [[\-h\fIhost\fB] [\-q\fIqueue\fB]|[\-P\fIprinter\fB]] [\-s] [\fI\-C\fB] [\fI\-v\fB] [\fI\-\\\\?\fB] [\fI\-E[E]\fB] [\fIusers\fB|\fIjobs\fB] [\fI\-m\fB] ..."
.sp
.B "flpk [[\-h\fIhost\fB] [\-q\fIqueue\fB]|[\-P\fIprinter\fB]] [\-l\fIlogin\fB] [\fI\-V[V]\fB] [\fI\-v\fB] [\fI\-\\\\?\fB] [\fI\-E[E]\fB] [\fIusers\fB|\fIjobs\fB] [\fI\-m\fB] ..."
.SH DESCRIPTION, SYSTEM ADMINSTRATION
The user level description is the next section.  But users are welcome
to read and understand this section.  The user and the system adminstrator
may be the same person.  Or, the user may have to diagnose a situation
and explain what needs to be done to the system administrator.
.PP
Not all of the programs and not all of the parameters work between any given
pair of systems.
.PP
\fBflpr\fP, \fBflpq\fP and \fBflpk\fP are normally installed as a single
with three hard links.  Symbolic links may be substituted.  The program
determines its function by examining its basename (the last component
of the filename used to invoke it).  To support alternate versions for
debugging and so forth the names can be prefixed by a single character
except `~' or `!'.  Since flpr may be linked to by printer nicknames to
establish that nickname as a default printer nickname, the checking order
is `flpr', printer nicknames and then single character extended names.
.PP
\fBflpr\fP, \fBflpq\fP and \fBflpk\fP must be installed setuid root
so that it can obtain a connection using the BSD lpd privileged port.
.RS 3
.TP 15
Normal UNIX:
chown root.sys flpr
.br
chmod 4511 flpr
.TP 15
BSD/Linux:
chown root.sys flpr
.br
chmod u=rsx,g=x,o=x flpr
.RE
.PP
If you do not use the funky text form parameter string in BSD or Linux,
then the chmod command \fIsilently\fP ignores the setuid bit specification.
For some very old UNIX variants, it may be necessary to use separate
chgrp sys and chgrp root commands.  In case of SunOS and a few other
variants, group sys may need to be replaced by group wheel or some
other group.
.SH DESCRIPTION, USER LEVEL
Not all of the programs and not all of the parameters work between any given
pair of systems.
.PP
All three programs will display a description of their arguments when
given an argument of
.B \-?\fP.
[For csh,
.B \-\\\\?
is required.]
Also, for each program as shown above, as applicable:
.RS 3
.TP 5
.B \-m
sends a man page for these programs to stdout.  The other options will
not be processed if this option is used.
.TP 5
.B \-C
displays the copyright notice that applies to both this documentation and
these programs,
.TP 5
.B \-v
displays the machine compiled on and the compilation date (\fBflpr\fP
also prints host, queue,
and login id data reflecting all sources of this data),
.TP 5
.B \-V
displays the lpr protocol file to be used.
The double \fB\-VV\fP option adds a display of the protocol exchange with the
remote \fBlpd\fP daemon.
.TP 5
.B \-E
toggles the display of expanded error messages containing, for example,
probable causes and suggested actions to correct.  The initial state
gives long form messages for error conditions. The states after that
alternate between short and long form messages for both error and
warning conditions.
.TP 5
.B \-S
requests the toggling of normal reports vs. error reporting only from flpr.
.TP 5
.B \-T
changes the form of the temporary filenames used in the \fBlpd\fP protocol
exchange to the form used in earlier versions of \fBflpr\fP.
The previous format was incompatible with \fBSUN lpd\fP daemons; but allowed
up to 333 temporary files.
The present format is compatible with both \fBSUN lpd\fP and \fBTGV\fP
(\fBDEC VAX\fP resident) \fBlpd\fP daemons; but only allows up to 51
temporary files.
.TP 5
.B \-h
specifies the host machine name.
.TP 5
.B \-q
specifies the print queue name on the host machine.
.TP 5
.B \-P
specifies a printer nickname with associated host and queue names.
.TP 5
.B \-l
specifies a user name on the host machine.
.TP 5
.B \-I
specified a format string describing an alternate jobname.
The string argument must contain only alphanumeric, underscores, hyphens,
dollar signs, or data item identifiers.
Data item identifiers are %f for the full file name (*stdin for standard
input), %b for the file basename (the portion after the last slash or the
full filename, if there is no slash), %h for the name of the machine the
request is ran on, or %l for the user name (either from input to flpr or
the user's login name, as approppriate).
.TP 5
.B \-Q
requests that \fBflpr\fP produce a listing of the defined printer nicknames
and terminate.
.TP 5
.B \-W[W]
requests that \fBflpr\fP produce a report of selected host name, printer
queue name, username to be used on banner page (if any), and the user's
home directory and terminate.
With a doubled W, i.e., -WW, the source of control data are also displayed.
.TP 5
.B \-@
produces a selected list of printer nicknames in the same format as the
\fB\-Q\fP option and terminates.  It takes an argument of either a substring
or a colon preceeded shell-style quoted regular expression.  For example,
-@ps lists printer nicknames with `ps' in the name.  -@:'b0*ps*' lists
printer nicknames that start with `b0' and have `ps' somewhere following
in the name.
.TP 5
.B \-s
produces the short form of the lpq report, if available from lpd server.
.RE
.PP
The documentation options suppress the normal operation of these programs.
.TP 5
.B flpr
the print program, can either print from stdin or from a list of files,
but not both stdin and a list of files.
It uses disk space in /usr/tmp for temporary storage of stdin data and
for control files.
It produces a report to stdout naming each file printed (*stdin for
standard input); the size of the file, which may be in bytes (B),
kilobytes (K), megabytes (M) or gigabytes (G); if the source is a file,
then the age of the file based on when it was last written, which may be
in days, hours, minutes and seconds, if less than a week from the present,
date and time if less than 180 days from the present and otherwise the
date and year; the print server's name and print queue name and a final
line indicating the completion of the request with the print server's
name again.  The print server's IP address is included in the last line
if flpr was compiled with that support.
.TP 5
.B flpq
the query program, has the capacity to request either a long or short
form output and select by users or jobs.
Some lpr daemons may not support these capacities.
.TP 5
.B flpk
the print request cancel program, has the capacity to request the
cancellation of output optionally selected by users or jobs names.
Some lpr daemons may not support these capacities.
.PP
There are defaults file whose names can be determined by executing \fBflpr\fP
with the \fB\-v\fP and \fB\-\\?\fP options that can contain default
values for the host, username, printer queue, protocol temporary filename
format and one or more associations between a `nickname' and a host and
printer queue pair.
These values are referenced first but if environment variables or
arguments are supplied, the values in the defaults file are ignored. 
The effect of the system defaults file is system wide.
The effect of the user's defaults file is for that user only.
.PP
The name of the system-wide defaults file is determined when the programs
are compiled.
It is usually either /itc/flp.defaults or /usr/local/etc/flp.defaults.  
The user's defaults file is usually $HOME/.flprrc.
.PP
If the first non-whitespace character on a line is a non-alphanumeric
character, if the line is entirely whitespace or has improper syntax,
then it is functionally a comment line.
.PP
The format of the defaults file is (one tag per line): optional whitespace,
a tag, whitespace, a value, optional whitespace and the end of the line.
The format of the defaults file nickname entries is (one entry per line):
optional whitespace, a tag, whitespace, a nickname, whitespace, a host name,
whitespace, a printer queue, optional whitespace and the end of the line.
.PP
The tags are:
.RS 3
.TP 5
.B host
\- the computer system where the target lpd is,
.TP 5
.B queue
\- a default printer queue on the 'host' computer system,
.TP 5
.B printer
\- specifies a relationship between, respectively, a printer
nickname, an associated host name and an associated queue name,
.TP 5
.B user
\- a default login name on the 'host' computer system(
this tag is only needed if the users login name on the host system is
different from the users login on the system the user is currently logged into),
.TP 5
.B fullname
\- user's full name,
.TP 5
.B files
\- the protocol temporary filename format (0 indicates TGV format,
1 indicates SUN format),
.TP 5
.B identifier
\- a jobname format string equivalent to the -I option, and
.TP 5
.B Eflag
\- desired error message level:
0 for short messages only; 1 for complete long messages
and -1 for long message without missing control files being commented upon
(the default).
.TP 5
.B silence
\- desired normal reporting level
0 for normal reports; 1 for errors, warnings and debugging reports only. 
The default is normal reports.
.RE
.PP
The effect of environment variables are system\-wide if defined in
\fB/etc/cshrc\fP or \fB/etc/profile\fP.
The effect can be individualized for a specific user in their shell
initialization files or by interactive input.
.PP
The following environmental variables may be used:
.RS 3
.TP 5
.B FLPHOST
\- the computer system where the target lpd is,
.TP 5
.B FLPQUE
\- the printer queue on computer system where the target lpd is,
.TP 5
.B FLPPRINTER
\- the printer nickname that specifies the computer system where the target
lpd is and the printer queue (if present FLPPRINTER overrides FLPHOST and
FLPQUE),
.TP 5
.B FLPUSER
\- a default login name on the 'host' computer system,
this tag is only needed if the users login name on
the host system is different from the users login
on the system the user is currently logged into,
.TP 5
.B FLPFILES
\- protocol temporary filename format, values similiar
to those for the defaults file \fBfiles\fP line.
.TP 5
.B FLPIDENT
\- a jobname format string equivalent the -I option.
.TP 5
.B FLPNAME
\- full name of user, should be shell quoted, if necessary.
.TP 5
.B FLPEFLAG
\- 0 for short messages only; 1 for complete long messages
and 1 for long message without missing control files being commented upon
(the default).
.TP 5
.B FLPSILENCE
\- desired normal reporting level
0 for normal reports; 1 for errors, warnings and debugging reports only. 
The default is normal reports.
.RE
.PP
Option value meanings are:
.RS 3
.TP 10
classname
banner page line item
.TP 10
file
name of file to be printed
.TP 10
fullname
banner page line item, intended to be user's full name
.TP 10
host
name, IP numeric address or IP dotted numeric address
of machine to receive material to be printed
(numeric may be C decimal, octal or hexadecimal integers.)
.TP 10
indent
columns to indent printing
.TP 10
jobname
banner page line item
.TP 10
jobs
print jobs in queue
.TP 10
login
login name to attribute print request to
.TP 10
notify
login name to send mail to notify of completion
.TP 10
queue
print queue to assign material to
.TP 10
users
login name of attributed user concerned
.TP 10
width
column width of printing
.RE
.PP
A link made from \fBflpr\fP of either the hard or symbolic type to a filename
whose basename is a printer nickname supplies a default nickname.
See `\fBCONTROL DATA PROCESSING\fP' near the bottom of this document
for a description of the priority of the control data sources.
.PP
For example of the feature mentioned just above, assume that you have a
\fI~/.flpprc\fP which contains:
.ft C
.if t .vs 0.95m
.RS 3
.sp
	host prtsrvr
.br
	queue myprinter
.br
	printer trans transsrvr trans_queue
.sp
.RS -3
.ft R
.if t .vs 1.2m
Then, if you have a \fI~/bin\fP in your shell PATH variable, then you can
do the following (the \fIrehash\fP command is needed only if you are using
a C family shell and you want it to use the link without resetting your
shell PATH variable by `set path=($path)' or logging out and back in):
.ft C
.if t .vs 0.95m
.RS 3
.sp
	cd ~/bin
.br
	ln -s /the/directory/where/is/flpr trans
.br
	rehash
.br
	trans myfile
.sp
.RS -3
.ft R
.if t .vs 1.2m
.SH CONTROL DATA PROCESSING
From highest to lowest, the priority of the data sources are: program
arguments, the base name of program as a link to \fBfile\fP, environment
variables (which may come from either the user's or the system's shell
start up files), the defaults file, and what may be compiled into the program.
The highest priority source is the data source used.  The source of the
respective control data items can be determined using the option \fB-WW\fP.
.SH "SEE ALSO"
lp(1)
.SH WARNINGS
If the print queue host is a DEC VAX running the DEC VMS operating system
and TGV Multinet, \fBflpk\fP does not work, \fBflpq\fP only gives the long
form output, and for \fBflpr\fP, only the \fB\-h\fP, \fB\-l\fP, \fB\-j\fP,
and \fB\-q\fP options are known to work.  By extension, since the \fB\-I\fP
uses the \fB\-j\fP facilities, it also works with this lpd implementation.
This package was written to be a complete implementation of the BSD lpd/lpr
protocol as a result options are available in the package that are not
supported on the VAX VMS host.
.SH VERSION
$Id: flpr.man,v 2.1 1999/01/25 19:51:43 root Exp root $
.SH AUTHOR
Randolph J. Herber

